#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ChatWord.h"
std::auto_ptr<M_ChatWord> M_ChatWord::msSingleton(nullptr);

int M_ChatWord::GetCount()
{
	return (int)mMapData.size();
}

const M_ChatWordData* M_ChatWord::GetData(int WordId)
{
	auto it = mMapData.find(WordId);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ChatWordData>& M_ChatWord::GetMapData()
{
	return mMapData;
}

void M_ChatWord::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ChatWord.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChatWordData data;
		data.mWordId = element->IntAttribute("WordId");
		data.mText = element->Attribute("Text");
		if (mMapData.find(data.mWordId) != mMapData.end())std::cout <<"data refind:" << data.mWordId << std::endl;
		CCASSERT(mMapData.find(data.mWordId) == mMapData.end(), "data.mWordId is exists");
		mMapData.insert(std::make_pair(data.mWordId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ChatWord Loaded. Load Data:%u", mMapData.size());
}

void M_ChatWord::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ChatWord");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ChatWord");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ChatWordData data;
		LuaCfgHelper::readInt(L, "WordId", data.mWordId);
		LuaCfgHelper::readString(L, "Text", data.mText);
		if (mMapData.find(data.mWordId) != mMapData.end())std::cout <<"data refind:" << data.mWordId << std::endl;
		CCASSERT(mMapData.find(data.mWordId) == mMapData.end(), "data.mWordId is exists");
		mMapData.insert(std::make_pair(data.mWordId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ChatWord Loaded. Load Data:%u", mMapData.size());
}

void M_ChatWord::Reload()
{
	mMapData.clear();
	Load();
}

M_ChatWord* M_ChatWord::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChatWord());
	}
	return msSingleton.get();
}

void M_ChatWord::Release()
{
	msSingleton.reset(nullptr);
}
